class ConnectionPool

  def initialize(opts, &block)
    @idle = []    #空闲的连接
    @active = {}  #活动的连接
    @pending = [] #等待的线程或纤程id
    opts[:size].times do
      @idle.push(block.call) if block_given?
    end
    @size = opts[:size]
    @state = true # mark this pool active
  end

	def execute
		raise NotImplementedError
	end

  # Returns current pool utilization.
  #
  # @return [Hash] Current utilization.
  def status
    {
      state: state,
      idle: @idle.size,
      active: @active.size,
      pending: @pending.size
    }
  end

	def destroy
		raise NotImplementedError
	end

end
